

if(typeof(BcseStarSelector) == 'undefined') {


var BcseStarSelector = {

	init: function() {
		var BSS = this;
		if (typeof(Modernizr) != 'undefined' && Modernizr.touch && BSS.replaceStars()) {
			return true;
		}
		$('.star-select')
			.live('click',BSS.BcseStarSelect)
			.live('mousedown',function(event) {
				var starClicked = BSS.BcseFindClickStar(event.target);

				if(!starClicked)
					return false;
				

				BSS.BcseRemoveAllStarView(event.currentTarget);
				BSS.BcseSetStarViewMouseDown(event.currentTarget,starClicked);

				setTimeout(function() {
					var currentVal = BSS.BcseSelectInputVal($(event.currentTarget).attr('data-star-selector-id'));

					BSS.BcseRemoveAllStarView(event.currentTarget);
					BSS.BcseSetStarViewMouseOut(event.currentTarget,currentVal);
				},125);
			})
			.live('mouseover',function(event) {
				var starClicked = BSS.BcseFindClickStar(event.target);

				if(!starClicked)
					return false;

				BSS.BcseRemoveAllStarView(event.currentTarget);
				BSS.BcseSetStarViewMouseOut(event.currentTarget,starClicked);
			})
			.live('mouseout',function(event) {
				var currentVal = BSS.BcseSelectInputVal($(event.currentTarget).attr('data-star-selector-id'));

				BSS.BcseRemoveAllStarView(event.currentTarget);
				BSS.BcseSetStarViewMouseOut(event.currentTarget,currentVal);
			})
			.each(function(idx,ele) {
				ele.BSS = BSS;

				var currentVal = BSS.BcseSelectInputVal($(ele).attr('data-star-selector-id'));
				BSS.BcseSetStarViewMouseOut(ele,currentVal);
			});
	},

	replaceStars: function() {
		$('input.star-select-input').each(function(){
			var $this = $(this);
			var $coldiv = $this.parents('div.column').eq(0);
			var name = $this.attr('name');
			var $sel = $coldiv.find('.nonstar-select-container select');
			if ($sel.size() < 1) {
				return true;
			}
			$coldiv.find('ul.star-select').hide(0);
			$sel.attr('name', name);
			$this.replaceWith($sel);
		});
		return true;
	},

	BcseGetSelectorInputEle: function(id) {
		return $('input.star-select-input[data-star-selector-id="'+id.replace('"','\\"')+'"]').get(0);
	},

	BcseGetSelectorGuiEle: function(id) {
		return $('ul.star-select[data-star-selector-id="'+id.replace('"','\\"')+'"]').get(0);
	},

	BcseSelectInputVal: function(id,newVal) {
		if(newVal == null) {
			return $(this.BcseGetSelectorInputEle(id)).val();
		} else
			return $(this.BcseGetSelectorInputEle(id)).val(newVal);
	},

	BcseStarSelect: function () {
		if(arguments.length == 2) {
			var selectorEle = arguments[0];
			var starClicked = arguments[1];
		}
		else {
			var event = arguments[0]
			
			var starClicked = event.currentTarget.BSS.BcseFindClickStar(event.target);

			if(!starClicked)
				return false;

			var selectorEle = event.currentTarget;
		}	

		selectorEle.BSS.BcseSelectInputVal($(selectorEle).attr('data-star-selector-id'),starClicked);
	},
	

	BcseFindClickStar: function(ele) {
		var classResult = /\bselect-(\d)\b/.exec($(ele).attr('class'));

		if(!classResult)
			return false;

		return classResult[1];
	},

	BcseSetStarViewMouseOut: function(ele,starCount) {
		this.BcseSetStarStyle(ele,starCount,'show-selected');
	},

	BcseRemoveStarViewMouseOut: function(ele,starCount) {
		this.BcseRemoveStarStyle(ele,starCount,'show-selected');
	},

	BcseSetStarViewMouseDown: function(ele,starCount) {
		this.BcseSetStarStyle(ele,starCount,'button-down');
	},

	BcseRemoveStarViewMouseDown: function(ele,starCount) {
		this.BcseRemoveStarStyle(ele,starCount,'butt-down');
	},
	
	BcseRemoveAllStarView: function(ele) {
		this.BcseRemoveStarStyle(ele,5,'show-selected');
		this.BcseRemoveStarStyle(ele,5,'button-down');
	},

	BcseSetStarStyle: function(ele,starCount,style) {
		var i = 1;
		$(ele).children('li').each(function(idx,ele) {
			if(i > starCount) {
				return false;
			}
			else if($(ele).hasClass('select-' + i)) {
				$(ele).addClass(style);
				i++;
			}
		});
	},

	BcseRemoveStarStyle: function(ele,starCount,style) {
		var i = 1;
		$(ele).children('li').each(function(idx,ele) {
			if(i > starCount) {
				return false;
			}
			else if($(ele).hasClass('select-' + i)) {
				$(ele).removeClass(style);
				i++;
			}
		});
	}
}

// NOTE: we need a newer version of jQuery to do a ready() on older mobile devices
$bcse(function() {
	BcseStarSelector.init();
});

}

