/* JLS - 2013-12-27
 * This file has helper scripts for things like dropdowns
 * */


/*
Textarea clone() bug workaround | Spencer Tipping
Licensed under the terms of the MIT source code license

Motivation.
jQuery's clone() method works in most cases, but it fails to copy the value of textareas. This patch replaces jQuery's clone() method with a wrapper that fills in textarea values.

soruce: https://github.com/spencertipping/jquery.fix.textarea-clone/blob/master/jquery.fix.textarea-clone.js.sdoc
*/

(function (original) {
  jQuery.fn.clone = function () {
    var       result = original.apply (this, arguments),
        my_textareas = this.find('textarea'),
    result_textareas = result.find('textarea');

    for (var i = 0, l = my_textareas.length; i < l; ++i)
      $(result_textareas[i]).val ($(my_textareas[i]).val());

    my_selects = this.filter('select');
    result_selects = result.filter('select');

    for (var i = 0, l = my_selects.length; i < l; ++i) 
      $(result_selects[i]).val ($(my_selects[i]).val());

    return result;
  };
}) (jQuery.fn.clone);


(function ($,undefined) {

	$.fn.extend({
		bcseGetFormEle: function(name) {
			//if(this.length == 1)
				return $(this.get(0).elements).bcseFilterByName(name);
			/*else {
				return this.filter(function(idx,ele) {
					if(ele.tagName.toUpperCase() == 'FORM')
						return true;
					
					return false;
				})
				.each(function(idx,ele) {
						
				});
			}*/
		},

		bcseFilterByName: function(name) {
			if(name === undefined)
				return $;

			return this.filter(function(idx,ele) {
				if($(ele).attr('name') == name)
					return true;

				return false;
			});
		},

		bcseFindByName: function(name) {
			if(name === undefined)
				return $;

			return this.find('[name]').bcseFilterByName(name);
		}
	});

	$.bcseFindByName = function(name) {
		if(name === undefined)
			return $;

		return $('[name]').bcseFilterByName(name);
	}

	
}) (jQuery);



//Expand Dialog widget to adjust to totaly screen size
(function ($, undefined) {

	var _create = $.ui.dialog.prototype._create;
	var open = $.ui.dialog.prototype.open;
	var close = $.ui.dialog.prototype.close;

	$.widget('bcse.dialog',$.ui.dialog,{

		_timeIntId: 0,
		origHeight: 0,
		origWidth: 0,
		mobileMode: false,
		mobileWidth: '768',
		forceMobile: false,

		_create: function() {
			_create.apply(this,arguments);

			var s = this;
			var currentTimerID = 0;

			// Add touch scrolling events if possible
			s._addTouchScrollEvents( s.uiDialog.children('.ui-dialog-content') );

			$(window).resize(function() {
				if(!currentTimerID) {
					currentTimerID = setTimeout(function() {
						currentTimerID = 0;		
						s._resize();
					},350);
				}
			});
		},

		_resize: function() {
			var s = this;
			var $win = $(window);
			var deskOrigHeight = 9999999999999999999;
			var heightOverflow = false;

			s._mobileSize();
				
			if(!s.mobileMode) {
				if($win.height() < s.uiDialog.height()) {
					if(heightOverflow)
						deskOrigHeight = s.uiDialog.height(); 

					s.uiDialog.height($win.height());
					heightOverflow = true;
				}
				else if(heightOverflow && $win.height() > deskOrigHeight) {
					s.uiDialog.height(deskOrigHeight);
					heightOverflow = false;
				}
			}

			if(s.mobileMode || heightOverflow) {
				var titleHeight = s.uiDialog.children('.ui-dialog-titlebar').outerHeight() + s.uiDialog.children('.bcse-dialog-button-area').outerHeight();
				s.uiDialog.children('.ui-dialog-content').css({
					'min-height' : 'none',
					'height' : (s.uiDialog.height() - titleHeight) + 'px',
				})
			}
			else {
				s.uiDialog.children('.ui-dialog-content').css({
					'height' : 'auto',
					'max-height' : '100%',
				});
			}

			s.element.dialog('option','position',{ 
				my: "center", at: "center", of: window
			});
		},

		open: function() {
			open.apply(this,arguments);

			this._resize();

			$('.ui-dialog').addClass('bcse-ui-dialog');

			this.uiDialog.children('.ui-dialog-buttonpane,.bcse-dialog-button-area').remove();
			
			if(this.options.buttons != undefined) {
				var buttonArea = $('<div/>');
				buttonArea.addClass('bcse-dialog-button-area');

				$.each(this.options.buttons,function(idx,val) {
					var button = $('<button/>');

					button.addClass('radius').attr('type','button');

					if(val.text) {
						button.html(val.text);
					}

					if(val.buttonClass) {
						button.addClass(val.buttonClass)
					}

					if(val.click != undefined) {
						button.click(val.click);
					}

					buttonArea.append(button);
				});

				this.uiDialog.append(buttonArea);
			}
		},

		close: function() {
			close.apply(this,arguments);

			clearInterval(this._timeIntId);
		},	

		// http://stackoverflow.com/questions/3845445/how-to-get-the-scroll-bar-with-css-overflow-on-ios
		_isTouchDevice: function() {
			// TODO: Modernizr.touch
			try {
				document.createEvent('TouchEvent');
				return true;
			} catch(e) {
				return false;
			}
		},
		_addTouchScrollEvents: function(elid) {
			var self = this;
			if (!self._isTouchDevice()) {
				return false;
			}
			if ('string' == typeof elid) {
				elid = '#' + elid;
			}
			var $els = $(elid);
			if ($els.size() < 1) {
				return false;
			}
			$els.each(function(){
				var scrollStartPos = 0;
				$(this)
				.bind('touchstart', function(e){
					e.preventDefault();
					var touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
					scrollStartPos = $(this).scrollTop() + touch.pageY;
				})
				.bind('touchmove', function(e){
					e.preventDefault();
					var touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
					$(this).scrollTop( scrollStartPos - touch.pageY );
				});
			});
			return true;
		},
		
		_isMobileMode: function() {
			var $win = $(window);

			return this.mobileWidth >= $win.width();
		},

		_mobileSize: function(force,doMobile) {
			
			if(typeof(force) != 'undefined') {
				this.forceMobile = force?true:false;
			}

			if(this.forceMobile && typeof(doMobile) != 'undefined')
				doMobile = doMobile?true:false;
			else
				doMobile = this.mobileMode;

			var $win = $(window);

			if((this.forceMobile && doMobile) || (!this.forceMobile && this._isMobileMode())) {
				if(!this.mobileMode) {
					this.origWidth = this.uiDialog.width();
					this.origHeight = this.uiDialog.height();
				}

				this.uiDialog.width($win.width());
				this.uiDialog.height($win.height());

				this.mobileMode = true;
			} 
			else if((this.forceMobile && !doMobile) || (!this.forceMobile && this.mobileMode)) {
				this.uiDialog.width(this.origWidth);
				this.uiDialog.css('height','auto');

				this.mobileMode = false;
			}

	
		},

	});
} (jQuery));


(function (original) {
	window.orignalAlert = original;

	window.alert = function(message,title) {
		var alertModal = $('<div></div>');

		if(typeof(title) == 'undefined')
			title = 'Message';

		alertModal.addClass('alert-modal');
		alertModal.html(message);
		alertModal.appendTo('div.body');

		alertModal.dialog({
			title: title,
			autoOpen: true,
			resizable: false,
			draggable: false,
			maxWidh: 400,
			modal: true,
			buttons: [{
				text: 'Okay',
				click: function() {
					alertModal.dialog('close').dialog('destroy');
				}
			}]	
		});
	};
})(window.alert);


(function (original) {
	window.originalConfirm = original;

	window.confirm = function(message,callback,title) {
		if(callback == undefined)
			return window.originalConfirm(message);

		var alertModal = $('<div></div>');

		if(title == undefined)
			title = 'Message';

		alertModal.addClass('alert-modal');
		alertModal.html(message);
		alertModal.appendTo('div.body');

		var choice = false;

		alertModal.dialog({
			title: title,
			autoOpen: true,
			resizable: false,
			draggable: false,
			maxWidh: 400,
			modal: true,
			buttons: [
				{
					text: 'Yes',
					click: function() {
						callback();
						alertModal.dialog('close').dialog('destory');
					}
				},
				{
					text: 'No',
					click: function() {
						alertModal.dialog('close').dialog('destory');
					}
				}
			]	
		});
	};
})(window.confirm);


function bcseInitMenuDropDown() {
	$('.drop-down-menu .title-bar').click(function() {
		bcseClickedMenuDropDown(this);
	});
}

function bcseFixFirefoxSelect () {
	var $div = $('<div></div>').addClass('firefox-fix-select');

	$('select').each(function(idx,ele) {
		var $ele = $(ele);

		if (
			!$ele.hasClass('stop-firefox-fix-select')
			&& !$ele.parent('.firefox-fix-select').length
		) {
			var $cloneDiv = $div.clone();

			$cloneDiv.get(0).style = $ele.get(0).style;
			$ele.get(0).style = '';
			$ele.after($cloneDiv).appendTo($cloneDiv);

			$cloneDiv.attr('data-select-disabled',$ele.attr('disabled'));
	
			var intervalID = setInterval(function() {
				if(!$cloneDiv.children('select').length) {
					var $childs = $cloneDiv.children();
					$cloneDiv.after($childs);
					$cloneDiv.remove();
					clearInterval(intervalID);
				}

				if($ele.length)
					$cloneDiv.attr('data-select-disabled',$ele.attr('disabled'));		
				else
					clearInterval(intervalID);
			},500);
		}
	});
}


function bcseModifyDialogWidget() {
	
}

function bcseClickedMenuDropDown(ele) {
	ajax.query.add({
		data: {
			action: 'set_menu',
			menu: $(ele).parent().attr('data-menu-name'),	
		}
	})


	var title = $(ele);
	var content = title.siblings('.content').first();

	content.slideToggle({
		complete: function() {
			title.find('img').toggle();
		}
	});
}


function bcseInitMobileSlideOut() {
	$('.slide-button').click(function() {
		bcseClickedMobileSlideBut();
	});
}

function bcseClickedMobileSlideBut() {
	if($('.slide-button .close').is(':visible'))
		bcseCloseLeftMenu();
	else
		bcseOpenLeftMenu();
}

function bcseCloseLeftMenu() {
	var menuObj = $('#left-bar .mobile,#left-bar-bg-mobile');

	$('#left-bar').addClass('close');

	$('.mobile-hide-on-slide').addClass('mobile-hide');

	menuObj.animate({
			width: '90px'
		},
		{
			duration: 300,
			complete: function() {
				if($(this).is('.mobile'))
					$('.slide-button').find('.open,.close').toggle();
			}
		}
	);
}

function bcseOpenLeftMenu() {
	var menuObj = $('#left-bar .mobile,#left-bar-bg-mobile');
	
	$('#left-bar').removeClass('close');

	menuObj.animate({
			width: '240px'
		},
		{
			duration: 300,
			complete: function() {
				if($(this).is('.mobile'))  {
					$('.slide-button').find('.open,.close').toggle();
					$('.mobile-hide-on-slide').removeClass('mobile-hide');
				}
			}
		}
	);
}



function bcseOpenCartMenu(el) {
	var cartCount = $('#header .cart-item-count');
	var cartMenu = $('#header .cart-menu-block');

	cartCount.addClass('active');
	cartMenu.addClass('active');

	if (el && $(el).attr('data-menuoption') && $(el).attr('data-menuoption') == 'move') {
		cartMenu.css('top', $(el).offset().top+'px');
	}

	$('.account-info').block({
		overlayCSS: {
			opacity: 0,
		},
		message: ''
	});
}

function bcseCloseCartMenu() {
	var cartCount = $('#header .cart-item-count');
	var cartMenu = $('#header .cart-menu-block');

	cartCount.removeClass('active');
	cartMenu.removeClass('active');

	$('.account-info').unblock();
}

function bcseLoadMinicartBlock() {
	return ajax.core.loadBlock($('#header .cart-menu-block'),'minicart',{},function() {
			$('.cart-item-count').html($('#bcse-cart-products-count').html());

			if(!$('#header').find('.cart-menu-block .mini-cart-row').length)
				bcseCloseCartMenu();
		});
}

function bcseInitMiniCartMenu() {
	$('#header').find('.cart-item-count').live('click',function(){
		var obj = $(this);

		if(obj.is('.active'))
			bcseCloseCartMenu();
		else
			bcseOpenCartMenu(obj);
	});

	$('#header').find('.cart-menu-block .cart-close-but').live('click',function() {
		bcseCloseCartMenu();
	});

	$('.minicart-delete').live('click',function() {
	      	$('#header .cart-menu-block').block();
		ajax.query.add({
			url: xcart_web_dir + '/cart.php?mode=delete&productindex=' + $(this).attr('bcse-product-index')
		});
	});

	$('.minicart-update').live('click',function() {
	      	$('#header .cart-menu-block').block();
		ajax.query.add({
			type: 'POST',
			url: xcart_web_dir + '/cart.php',
			data: $(document.forms['bcseminicartform']).serialize()
		});
	});

	  $(ajax.messages).bind(
	    'cartChanged',
	    function(e, data) {
	      return bcseLoadMinicartBlock();
	    }
	  );	

	bcseLoadMinicartBlock()
}


function bcseInitAvatarDropDown() {
	return true;
}


function bcseInitSearchBar() {
	var searchBarCont = $('#large_search_bar');

	searchBarCont
	.find('input.search-text')
	.focus(function() {
		searchBarCont.addClass('no-opacity');
	})
	.blur(function() {
		searchBarCont.removeClass('no-opacity');
	});
}

// Mobile Swipe - 2015-01-29
function bcseInitMobileSwipeEvents() {
	(function($){
		$('#left-bar.close #left-mobile').bind('swiperight', function(){
			if (! $('.slide-button .close').is(':visible')) {
				bcseOpenLeftMenu();
			}
		});
		$('#left-bar #left-mobile').bind('swipeleft', function(){
			if ($('.slide-button .close').is(':visible')) {
				bcseCloseLeftMenu();
			}
		});
		// note: jquery 1.10 doesn't have live => use .on()
		//$('.images-preview .box').live('swipeleft', function(){
		$('.images-preview .box').on('swipeleft', function(){
			return true;
		});
	// requires the newer version of jQuery (1.10):
	})($bcse);
}

function bcseInitViewportSelect() {
	// idea from: https://github.com/chrismorata/Responsive-View-Full-Site
	(function($){

		// viewport stuff
		var targetWidth = 980;
		var deviceWidth = 'device-width';
		var viewport = $('meta[name="viewport"]');

		// check to see if local storage value is set on page load
		// TODO: use cookies if not localStorage
		if ('undefined' != typeof localStorage) {
			localStorage.isResponsive = (localStorage.isResponsive == undefined) ? 'true' : localStorage.isResponsive;
		}

		var showFullSite = function(){    
			viewport.attr('content', 'width=' + targetWidth);
			$('.link-view-responsive').show(0);
			if ('undefined' != typeof localStorage) {
				localStorage.isResponsive = 'false';
			}
			document.cookie = "is_responsive=false";
		}

		var showMobileOptimized = function(){
			$('.link-view-responsive').hide(0);
			if ('undefined' != typeof localStorage) {
				localStorage.isResponsive = 'true';
			}
			viewport.attr('content', 'width=' + deviceWidth);
			document.cookie = "is_responsive=true";
		}

		// if the user previously chose to view full site, change the viewport
		if ('undefined' != typeof localStorage) {
			if (localStorage.isResponsive == 'false') {
				showFullSite();
			}
		}

		$('.link-view-full').on('click', function(){
			showFullSite();
			//window.setTimeout(showFullSite, 50);
			//window.setTimeout(showMobileOptimized, 50);
			$(this).parents('.f-dropdown.hover-drop-down').eq(0).css('left','-99999px');
		});

		$('.link-view-responsive').on('click', function(){
			showMobileOptimized();
			//window.setTimeout(showMobileOptimized, 50);
			$(this).parents('.f-dropdown.hover-drop-down').eq(0).css('left','-99999px');
		});

	// requires the newer version of jQuery (1.10):
	})($bcse);
}

$(function(){
	bcseInitSearchBar();
	bcseInitMenuDropDown();
	bcseInitMobileSlideOut();
	bcseInitMiniCartMenu();
	bcseInitAvatarDropDown();
	bcseInitViewportSelect();

	bcseInitMobileSwipeEvents(); // Mobile Swipe - 2015-01-29

	$('[date-bcse-overflow]').dotdotdot({
		watch: true
	});

	if($.browser.mozilla) {
		bcseFixFirefoxSelect();
		
		$(document).ajaxComplete(function() {
			bcseFixFirefoxSelect();
		});


		$('body').live('change',function() {
			bcseFixFirefoxSelect();
		});
	}
	

	$(ajax.messages).bind('changeLoginStatus',function(e,data) {
		$('.active-links').block();
		$.get(
			'get_header.php',
			function(data,textStats,jqXHR) {
				$('.active-links').html($(data).find('.active-links').html());
				bcseLoadMinicartBlock();
			}
		);
	});
});

