/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
| Smart Search :: alteredCart.com
| All code developed by Bill Brewer
| Copyright (c)2007-2012 alteredCart            
| Bill Brewer <bill@alteredcart.com>   
| All rights reserved.
| This code is licensed for use on a single server.
| This code is licensed for use by the original purchaser only.                         
| Full license :: www.alteredcart.com/license.php
|-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

var smartSearch = {

	/**
	* Show/Hide the advanced search dialog
	*/
	toggleAdvanced:function(display){

		if (display){
			$('#advancedSearch').show();
			$('#mainSearch').hide();
		} else {
			$('#advancedSearch').hide();
			$('#mainSearch').show(400, function(){try { $(window).resize(); } catch(e){}});
		}	
	},
	
	/**
	* Error check/submit the advanced search
	*/
	submitAdvanced:function(){

		if (!$('#all_the_words').val() && !$('#exact_phrase').val() && !$('#without_the_words').val() && !$('#at_least').val()){
			alert (error_alert);
			return false;	
		}
		
		// Clear any readonly fields //
		$('#smart_search_advanced input').each(function(){
			if ($(this).attr('readonly')){
				$(this).val('');
			}
		});
	
		document.smart_search_advanced.submit();

	},

	/**
	* Disable/Enable fields based on the fields the customer is entering data into
	*/
	toggleFields:function(){
	
		this.toggleReadonly('exact_phrase', 0);
		this.toggleReadonly('all_the_words', 0);
		this.toggleReadonly('at_least', 0);
		
		if ($('#at_least').val()){
			this.toggleReadonly('all_the_words', 1);
			this.toggleReadonly('without_the_words', 0);
		}
		
		if ($('#all_the_words').val()){
			this.toggleReadonly('at_least', 1);
			this.toggleReadonly('exact_phrase', 1);
			this.toggleReadonly('without_the_words', 0);
		}
		
		if ($('#exact_phrase').val()){
			this.toggleReadonly('all_the_words', 1);
			this.toggleReadonly('at_least', 1);
			this.toggleReadonly('without_the_words', 0);
		}	
	},

	/**
	* Enable/Disable certain advanced search fields based on the fields being changed
	*/
	toggleReadonly:function(obj, readonly){
		
		var obj = $('#'+obj);
	
		if (!obj[0]){
			return;
		}
		
		if (readonly){
			obj.val('');
			obj.attr({readonly:'readonly'});
			obj.addClass('readonly');
		} else {
			obj.removeAttr('readonly');
			obj.removeClass('readonly');
		}	
	},
	
	// Hide an element while hiding another //
	showDescr:function(hide, show){
		$('#'+hide).hide();
		$('#'+show).show();
	}
};

AJAXSearch = {};

AJAXSearch.setCategory = function(){
	
	$('#selectedCategoryText').html($('#categorySelectOptions option:selected').text());
	
};

/**
* AJAX Suggest class
* This class will create the suggestion box and position it on the page relaltive to the search box.
* The ID of this will this.id, and the main display will be middleHTML(body), bottomHTML
*
*/
function AJAXSuggest(){

	/** 
	* Setup an AJAX search on a form text field
	*
	* @param obj		Obj  The text field to attach the auto-search.
	* @param searchFunc Func Function to execute.  Will populate the search results.
	* @param container	Str  Optional field to to align the search results with if not the search input field.
	* @param img		Str  Path to am image to display as the search is running
	*/
	this.init = function(obj, searchFunc, container, img){

		var obj = this.obj = $('#'+obj);
		this.searchDisplay = 'AJAXsearch-'+obj.attr('id');
		this.searchFunc = searchFunc;
		this.container = typeof(container) != 'undefined' ? container : false;
		this.img = typeof(img) != 'undefined' ? img : false;

		// Turn off the browsers built in suggestions //
		obj.attr('autocomplete', 'off');
		var self = this;
			
		$(document).click(function(e){
			e = e || window.event;
			if (!$(e.target).is('#'+self.searchDisplay) && !$(e.target).parents().is('#'+self.searchDisplay) && !$(e.target).is('#'+self.obj.attr('id')) && !$(e.target).parents().is('#'+self.obj.attr('id'))){
				$('#'+self.searchDisplay).css({display:'none'});//hide('blind', '', 'slow');
			}
		});

		// Add an event to handle the up and down arrows //
		obj.keydown(function(e){

			e = e || window.event;
			var obj = e.target;
			var selected = false;		
	
			// Array of available tags in the search suggestion box //
			var tags = document.getElementById(self.searchDisplay).getElementsByTagName('dd');

			for (i=0; i<tags.length; i++){
				if ($(tags[i]).hasClass('highlighted')){
					selected = i;
					$(tags[i]).removeClass('highlighted');
					break;
				}
			}
			
			// Up arrow //
			if (e.keyCode == 38){

				if (selected == 0){
					self.highlight(tags[tags.length-1]);
				} else {
					self.highlight(tags[selected-1]);
				}

			} else if (e.keyCode == 40){ // Down arrow //

				if (typeof(selected) != 'number' || !tags[selected+1]){
					self.highlight(tags[0]);
				} else {
					self.highlight(tags[selected+1]);
				}
			}
		});
		
		// Handle the search //
		obj.keyup(function(e){ self.query(e); });
		
		// Create the quick search display //
		var c = self.container ? $('body') : obj.parent();		
		$('body').append('<div style="display:none;" id="'+this.searchDisplay+'" class="AJAXSearch">'+this.searching()+'</div>');
		
		(this.resize = function(){								
			var searchDisplay = self.searchDisplay;
			var offset = self.container ? $('#'+self.container).offset() : self.obj.offset();
			var height = 38;//self.container ? $('#'+self.container).height() : obj.height()+4;
			
			//if (obj.attr('id') == 'smartSearchSiteQ'){} // Custom offsets //
			
			// Display left or right //
			if (offset.left > $(document).width()/2){
				var padding = parseInt($('#smartSearchSiteQ').css('padding-right').replace(/px$/, ''))+parseInt($('#smartSearchSiteQ').css('padding-left').replace(/px$/, ''))+2 // +2 for the border //
				$('#'+searchDisplay).css({right:$(document).width()-offset.left-obj.width()-padding+'px', top:offset.top+height+2+'px', 'min-width':obj.css('width')});
			} else {			
				$('#'+searchDisplay).css({left:offset.left+'px', top:offset.top+height+2+'px', 'min-width':obj.css('width')});
			}
		})();
		
		$(window).resize(this.resize);

	};	
	
	/**
	* Highlight an item in the AJAX search by hover or arrow
	*/
	this.highlight = function(dd){
		
		// Copy the title of this element into the search query box //
		if (dd.title){
			this.obj.val(jQuery.trim(dd.title));
		}
		
		$(dd).addClass('highlighted');		
	}
		
	/**
	* Autosearch the query string is typed
	*
	* @param string str Query string to search
	*/
	this.query = function(e){
		
		e = e || window.event;
		
		// Don't do anything on certain key strokes like arrows or spaces //
		if (!e.keyCode || jQuery.inArray(e.keyCode, [9, 13, 16, 17, 18, 19, 20, 27, 32, 33, 34, 35, 36, 37, 38, 39, 40, 45, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123]) > -1){
			return;
		}

		var str = jQuery.trim($(e.target).val());
		var categoryid = jQuery.trim($(e.target.form.categoryid).val());
		var dropdown = $('#'+this.searchDisplay);

		// Too short, or empty query //
		if (str.length < 3){
			dropdown.css({display:'none'});//hide('blind', '', 'slow');
			return;
		}

		// After an arrow up or down this may be a stored query, if so don't auto search every time this changes //
		if (str == this.storedQuery){
			this.storedQuery = '';
			return;
		}

		// The search can be called by an arrow up or down, but the query may not change //
		if (str == this.previousSearch){
			return;
		} else {
			this.previoussSearch = str;
		}

		dropdown[0].innerHTML = this.searching();
		dropdown.show()	;
		var self = this;

		/*  Wait 150ms before exectuting this query.  The user may be typing so fast that this search 
			is already irrelevant */
		setTimeout(function(){
			if(str == jQuery.trim($(e.target).val()))
				self.searchFunc(str, categoryid, self);
			}, 300);
	};

	/**
	* Display or change the contents of the suggest box.  
	* If no arguments are passed the suggest box will be hidden.
	* If only one argument is passed it will be displayed in the middle section
	*
	* @param text string HTML to insert in the middle section of the suggest box
	* @param bottomText string HTML to insert in the bottom section of the suggest box [optional]
	*
	*/
	this.display = function(results){
		
		var dropdown = $('#'+this.searchDisplay);
		var self = this;
	
		if (jQuery.trim(results)){
			dropdown[0].innerHTML = results;
			dropdown.show()	;
			
			// Add the onhover highlights //
			$('#AJAXsearch-smartSearchSiteQ dd').each(function(){
				$(this).mouseover(function(){
					$('#AJAXsearch-smartSearchSiteQ dd').each(function(){ $(this).removeClass('highlighted'); });
					self.highlight(this);
				});
			});

		} else {
			dropdown.css({display:'none'});//hide('blind', '', 'slow');
		}
	};

	/** 
	* Display a searching graphic while the search is taking place
	*/
	this.searching = function(){

		return '<div style="text-align:center; margin:10px;">'+(this.img ? '<img src="'+this.img+'" alt="" />' : '')+'<div style="margin-top:15px;">Searching...</div><div>';

	};

	/**
	* Show incorrect spelling
	*
	* @param Array words Words that are spelled incorrectly
	*/
	this.displaySIC = function(words){

		string = kbSearch.e.textField.value;

		// Create a string from the words array //
		for (i=0; i<words.length; i++){
		
			string.replace(words[i], '<span class="incorrectSpelling">'+words[i]+'</span>');
		
		}
				
		sic = document.getElementsByClassName('incorrectSpelling');
		sicDiv = document.getElementsByClassName('incorrectSpellingDiv');
		ac.$('spellCorrectionDisplay').innerHTML = string;
		ac.$('spellCorrectionDisplay').style.display = '';
		
		// Remove any existing corrections //
		for (i=0; i<sicDiv.length; i++){
			sicDiv[i].parentNode.removeChild(sicDiv[i]);
		}
		
		for (var i=0; i<sic.length; i++){
			
			offsets = ac.calculateOffsets(sic[i]);
		
			// Create the div to display //
			newSIC = ac.createElem({node:'div', className:'incorrectSpellingDiv'});
			ac.$(newSIC).style.top = offsets.y+offsets.height+'px';
			ac.$(newSIC).style.left = offsets.x+'px';
			ac.$(newSIC).style.width = offsets.width+'px';
		
		}
		
		ac.$('spellCorrectionDisplay').style.display = 'none';

	};
}

var searchq = function(q, categoryid, caller){
	
	if (typeof(request) != 'undefined'){
		request.abort();
	}
	
	request = $.ajax({
		url:'_search.php',//'http://'+window.location.hostname+'/_search.php',
		cache:false,
		data:{'q':q, 'categoryid':categoryid, 'action':'ajax_search'},
		dataType:'text',
		success:function(html){ caller.display(html); }
	});
}